#!/usr/bin/perl

my $flash_dev = `grep spiflash /proc/mtd|head -c 4`;
my $configdata = `dd if=/dev/$flash_dev bs=1 skip=8257536 count=400`;

my ($magic, $cksum, $rev, $boardName, $major, $minor, $config,
$resetConfigGpio, $sysLedGpio, $cpuFreq, $sysFreq, $cntFreq,
$wlan0Mac, $enet0Mac, $enet1Mac, $pciId, $memCap, $wlan1Mac,
$serial_number) = unpack("LSSZ[64]SSLSSLLLa[6]a[6]a[6]SSa[6]Z[12]",
$configdata);

printf("magic: %d (0x%x)\n", $magic, $magic);
printf("cksum: %d (0x%x)\n", $cksum, $cksum);
printf("rev: %d (0x%x)\n", $rev, $rev);
printf("boardName: %s\n", $boardName);
printf("major: %d (0x%x)\n", $major, $major);
printf("minor: %d (0x%x)\n", $minor, $minor);
printf("config: %d (0x%x)\n", $config, $config);
printf("resetConfigGpio: %d (0x%x)\n", $resetConfigGpio, $resetConfigGpio);
printf("sysLedGpio: %d (0x%x)\n", $sysLedGpio, $sysLedGpio);
printf("cpuFreq: %d (0x%x)\n", $cpuFreq, $cpuFreq);
printf("sysFreq: %d (0x%x)\n", $sysFreq, $sysFreq);
printf("cntFreq: %d (0x%x)\n", $cntFreq, $cntFreq);
#printf("wlan0Mac: %d (0x%x)\n", $wlan0Mac, $wlan0Mac);
#printf("enet0Mac: %d (0x%x)\n", $enet0Mac, $enet0Mac);
#printf("enet1Mac: %d (0x%x)\n", $enet1Mac, $enet1Mac);
printf("pciId: %d (0x%x)\n", $pciId, $pciId);
printf("memCap: %d (0x%x)\n", $memCap, $memCap);
#printf("wlan1Mac: %d (0x%x)\n", $wlan1Mac, $wlan1Mac);
printf("serial_number: %s\n", $serial_number);

